name: linux-aarch64

on:
  push:
    branches:
      - main
      - release/*
    tags:
      - ciflow/linux-aarch64/*
      - ciflow/trunk/*
  workflow_dispatch:

concurrency:
  group: ${{ github.workflow }}-${{ github.event.pull_request.number || github.sha }}-${{ github.event_name == 'workflow_dispatch' }} but found ${{ github.workflow }}-${{ github.event.pull_request.number || github.ref_name }}-${{ github.ref_type == 'branch' && github.sha }}-${{ github.event_name == 'workflow_dispatch' }}-${{ github.event_name == 'schedule' }}
  cancel-in-progress: true

jobs:

  get-label-type:
    if: github.repository_owner == 'pytorch'
    name: get-label-type
    uses: pytorch/pytorch/.github/workflows/_runner-determinator.yml@release/2.7
    with:
      triggering_actor: ${{ github.triggering_actor }}
      issue_owner: ${{ github.event.pull_request.user.login || github.event.issue.user.login }}
      curr_branch: ${{ github.head_ref || github.ref_name }}
      curr_ref_type: ${{ github.ref_type }}

  linux-jammy-aarch64-py3_10-build:
    name: linux-jammy-aarch64-py3.10
    uses: ./.github/workflows/_linux-build.yml
    needs: get-label-type
    with:
      runner_prefix: ${{ needs.get-label-type.outputs.label-type }}
      build-environment: linux-jammy-aarch64-py3.10
      docker-image-name: pytorch-linux-jammy-aarch64-py3.10-gcc11
      runner: linux.arm64.2xlarge
      test-matrix: |
        { include: [
          { config: "default", shard: 1, num_shards: 4, runner: "linux.arm64.2xlarge" },
          { config: "default", shard: 2, num_shards: 4, runner: "linux.arm64.2xlarge" },
          { config: "default", shard: 3, num_shards: 4, runner: "linux.arm64.2xlarge" },
          { config: "default", shard: 4, num_shards: 4, runner: "linux.arm64.2xlarge" },
          { config: "default", shard: 1, num_shards: 3, runner: "linux.arm64.m7g.4xlarge" },
          { config: "default", shard: 2, num_shards: 3, runner: "linux.arm64.m7g.4xlarge" },
          { config: "default", shard: 3, num_shards: 3, runner: "linux.arm64.m7g.4xlarge" },
        ]}
    secrets: inherit

  linux-jammy-aarch64-py3_10-test:
    name: linux-jammy-aarch64-py3.10
    uses: ./.github/workflows/_linux-test.yml
    needs: linux-jammy-aarch64-py3_10-build
    permissions:
      id-token: write
      contents: read
    with:
      build-environment: linux-jammy-aarch64-py3.10
      docker-image: ${{ needs.linux-jammy-aarch64-py3_10-build.outputs.docker-image }}
      test-matrix: ${{ needs.linux-jammy-aarch64-py3_10-build.outputs.test-matrix }}
    secrets: inherit
